<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOutrosTerceirosERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOutrosTerceirosERP
 * @subpackage Arrays
 */
class ArrayOfOutrosTerceirosERP extends AbstractStructArrayBase
{
    /**
     * The OutrosTerceirosERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OutrosTerceirosERP[]
     */
    public $OutrosTerceirosERP;
    /**
     * Constructor method for ArrayOfOutrosTerceirosERP
     * @uses ArrayOfOutrosTerceirosERP::setOutrosTerceirosERP()
     * @param \StructType\OutrosTerceirosERP[] $outrosTerceirosERP
     */
    public function __construct(array $outrosTerceirosERP = array())
    {
        $this
            ->setOutrosTerceirosERP($outrosTerceirosERP);
    }
    /**
     * Get OutrosTerceirosERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OutrosTerceirosERP[]|null
     */
    public function getOutrosTerceirosERP()
    {
        return isset($this->OutrosTerceirosERP) ? $this->OutrosTerceirosERP : null;
    }
    /**
     * Set OutrosTerceirosERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OutrosTerceirosERP[] $outrosTerceirosERP
     * @return \ArrayType\ArrayOfOutrosTerceirosERP
     */
    public function setOutrosTerceirosERP(array $outrosTerceirosERP = array())
    {
        foreach ($outrosTerceirosERP as $arrayOfOutrosTerceirosERPOutrosTerceirosERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfOutrosTerceirosERPOutrosTerceirosERPItem instanceof \StructType\OutrosTerceirosERP) {
                throw new \InvalidArgumentException(sprintf('The OutrosTerceirosERP property can only contain items of \StructType\OutrosTerceirosERP, "%s" given', is_object($arrayOfOutrosTerceirosERPOutrosTerceirosERPItem) ? get_class($arrayOfOutrosTerceirosERPOutrosTerceirosERPItem) : gettype($arrayOfOutrosTerceirosERPOutrosTerceirosERPItem)), __LINE__);
            }
        }
        if (is_null($outrosTerceirosERP) || (is_array($outrosTerceirosERP) && empty($outrosTerceirosERP))) {
            unset($this->OutrosTerceirosERP);
        } else {
            $this->OutrosTerceirosERP = $outrosTerceirosERP;
        }
        return $this;
    }
    /**
     * Add item to OutrosTerceirosERP value
     * @throws \InvalidArgumentException
     * @param \StructType\OutrosTerceirosERP $item
     * @return \ArrayType\ArrayOfOutrosTerceirosERP
     */
    public function addToOutrosTerceirosERP(\StructType\OutrosTerceirosERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OutrosTerceirosERP) {
            throw new \InvalidArgumentException(sprintf('The OutrosTerceirosERP property can only contain items of \StructType\OutrosTerceirosERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->OutrosTerceirosERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OutrosTerceirosERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OutrosTerceirosERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OutrosTerceirosERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OutrosTerceirosERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OutrosTerceirosERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OutrosTerceirosERP
     */
    public function getAttributeName()
    {
        return 'OutrosTerceirosERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfOutrosTerceirosERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
